#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void dining_move_backward(void);
void necromancy(void);
void necromancy_end(void);

int area_dining(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("%nlμ%nlĤ¤Ǥ롣",
	  				ni_table, ni_chair);
            message("ظȺ%nw%nw%nw롣",
                    ni_back_door, ni_left_door, ni_right_door);
            
            if (Is(hall_dining_door_opened)){
                message("ظϸإ̤ۡƤ롣");
            }
            if (Is(dining_living_door_opened) &&
                Is(dining_kitchen_door_opened))
            {
                message("ϡ줾줾֤̤Ƥ롣");
            }
            else if (Is(dining_living_door_opened)){
                message("¦ϵ֤̤Ƥ롣");
            }
            else if (Is(dining_kitchen_door_opened)){
                message("¦̤Ƥ롣");
            }
            return 1;
        case vi_backward:
			if (Not(hall_dining_door_unlocked)){
				msg_door_unlocked_by_opening();
		        Set(hall_dining_door_unlocked);
			}
		    EnterDoor(entrance_hall, hall_dining);
			return 1;
        case vi_left:
            EnterDoor(living, dining_living);
            return 1;
        case vi_right:
            EnterDoor(kitchen, dining_kitchen);
            return 1;
		case vi_pray:
			necromancy();
			return 1;
        default:
            break;
		}
		break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
        break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
	case ni_table:
        switch (vid){
    	case vi_look:
			if (Is(candle_lit)){
				message("ơ֥ξˤϡ򤷤ο郎¤Ǥ롣\\");
				if (Not(chicken_bone_taken)){
					message("λˤϡ%nlĤäƤ롣",
				     		ni_chicken_bone);
				}
				else {
					message("");
				}
			}
			else {
				message("ơ֥ξˤϿ郎¤ӡ줫鿩Ϥ褦ȤƤ뤫Τ褦");
			}
			if (Not(candle_taken)){
				message("ơ֥üοˤ%nlΩäƤ롣",
						ni_candle);
			}
            return 1;
		default:
			break;
		}
		break;
	case ni_chicken_bone:
		if (Not(candle_lit)) ReturnNotExist;
		if (has_item(nid)) ReturnNotExist;
        switch (vid){
    	case vi_get:
			command_get_item(nid, fi_chicken_bone_taken);
            return 1;
		default:
			break;
		}
		break;
	case ni_chair:
        switch(vid){
    	case vi_look:
			if (Not(swordman_taken)){
				message("ػҤΰĤˤ%nläƤ롣",
						ni_toy_swordman);
			}
			return 1;
		default:
			break;
		}
		break;
	case ni_chicken:
        if (has_item(nid)){
            switch(vid){
            case vi_put:
				command_put_item(nid, fi_chicken_put, NULL);
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
			if (Not(chicken_put)){
				ReturnNotExist;
			}
		}
        break;
	case ni_glasses:
        if (has_item(nid)){
            switch(vid){
            case vi_put:
				command_put_item(nid, fi_glasses_put, NULL);
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
			if (Not(glasses_put)){
				ReturnNotExist;
			}
		}
		break;
	case ni_necklace:
        if (has_item(nid)){
            switch(vid){
            case vi_put:
				command_put_item(nid, fi_necklace_put, NULL);
                return 1;
            default:
                break;
            }
            return 0;
		}
		else {
			if (Not(necklace_put)){
				ReturnNotExist;
			}
		}
		break;
	case ni_plush_cat:
        if (has_item(nid)){
            switch(vid){
            case vi_put:
				command_put_item(nid, fi_plush_cat_put, NULL);
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
			if (Not(plush_cat_put)){
				ReturnNotExist;
			}
		}
        break;
	case ni_large_robot:
        if (has_item(nid)){
            switch(vid){
            case vi_put:
				command_put_item(nid, fi_large_robot_put, NULL);
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
			if (Not(large_robot_put)){
				ReturnNotExist;
			}
		}
        break;
	case ni_toy_swordman:
		if (has_item(nid)){
		    switch (vid){
			default:
				break;
			}
		}
		else {
	        switch (vid){
			case vi_get:
				command_get_item(nid, fi_swordman_taken);
				return 1;
			default:
				break;
			}
		}
		break;
	case ni_candle:
		if (has_item(nid)){
		    switch (vid){
			case vi_put:
				message("Ϲᤷ");
				lose_item(ni_candle);
				Reset(candle_taken);
				return 1;
			default:
				break;
			}
		}
		else {
	        switch (vid){
			case vi_get:
				command_get_item(nid, fi_candle_taken);
				return 1;
			default:
				break;
			}
		}
		break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}


void necromancy(void){
	if (Not(glasses_put) &&
		Is(necklace_put) &&
		Is(plush_cat_put) &&
		Is(large_robot_put))
	{
		message("ˡΤ㤯褦ʹ롣");
		return;
	}
	if (Is(glasses_put) &&
		Not(necklace_put) &&
		Is(plush_cat_put) &&
		Is(large_robot_put))
	{
		message("ˡΤ㤯褦ʹ롣");
		return;
	}
	if (Is(glasses_put) &&
		Is(necklace_put) &&
		Not(plush_cat_put) &&
		Is(large_robot_put))
	{
		message("ˡΤ㤯褦ʹ롣");
		return;
	}
	if (Is(glasses_put) &&
		Is(necklace_put) &&
		Is(plush_cat_put) &&
		Not(large_robot_put))
	{
		message("ˡǯΤ㤯褦ʹ롣");
		return;
	}
	if (Is(glasses_put) &&
		Is(necklace_put) &&
		Is(plush_cat_put) &&
		Is(large_robot_put))
	{
		if (Not(chicken_put)){
			message("ï̵ǰί©ϳ餷");
			return;
		}
		if (Is(candle_taken)){
			message("ï̵ǰί©ϳ餷");
			return;
		}
		// 桢äɽä
		Reset(glasses_put);
		Reset(necklace_put);
		Reset(plush_cat_put);
		Reset(large_robot_put);
		Set(candle_lit);
		Set(ghost_appeared);
		message("ʤͤοͱƤƲäƤ");
		message("ǯ˽ȻҶļ̿Υ襷ζȤ");
		message("餬ˤĤϹꡢ"
				"Ϥޤä"
				"ڤ˲ä路Ƥ褦"
				"餫ˤμԤǤϤʤϡʤˤʹʤ");
		set_wait_return_callback(necromancy_end);
	}
	else {  // 夬2İʾ­
		message("ˡ㤯褦ʹ롣");
		return;
	}
}
void necromancy_end(void){
	message("\n"
			"䤬ƿȡ׿ͤȻҶϿƲФƹԤä"
			"Ĥä襷ζϡʤ˲Ϲؤȡ"
			"ʻҤθɤä");
	// ϻĤ
	Set(glasses_put);
	Set(necklace_put);
	Set(plush_cat_put);
	Set(large_robot_put);
	// äƤݾƤѤ
	Reset(chicken_put);
	// ͩ
	Reset(ghost_appeared);
}
