#ifndef STATUS_H
#define STATUS_H
#include <stdio.h>
#include "area.h"

#define ITEM_MAX 256
#define FLAG_SEQUENCE_MAXLEN 16

typedef enum {
    im_english, im_hiragana, im_katakana
} input_mode_t;

// Ƽե饰ID
// 礷0ǽǤ褦ˡ֤٤Ƶˤʤ褦롣
// 񤷤ʤƥϽե饰ǷѤǤ뤿ᡢǼե饰Ѱդʤ
// (û륱Ǥϼե饰Ѱդ)
// ''ϥꥢ̵طʥե饰
// ''϶ŪONˤʤ륤٥ȥե饰
typedef enum {
    fi_invalid = -1,
    fi_begin = 0,
	fi_save_forbidden = 0,      // !֥ޥɤػߤƤ

    fi_entrance_unlocked,       // ؤ⤬Ƥ
    fi_mailbox_opened,          // ͹ؼƤ
    fi_mailbox_has_closed,      // ͹ؼĤȤ(ٳĤ)
    fi_leaflet_taken,           // 饷
    fi_medal_taken,             // 

	fi_newspaper_looked,        // ʹ򸫤

	fi_flowerpot_moved,         // ȭư
    fi_flowerpot_destroyed,     // ȭ
	fi_brass_key_taken,         // 﫤θ
	fi_wooden_key_taken,        // ڤθ
    fi_entered_house,           // ߤä

    //    fi_start_phone_call,        // äĤϤ᤿
	fi_phone_call_continued,    // äĤ³Ƥ(ʸON)
	fi_stop_phone_call,         // äĤ꽪ä
	fi_phone_call_stopped,      // äĤ꽪ä(ʸON)
	fi_phone_call_answered,     // äȤäʹ
	fi_photo_checked,           // ̿򸫤
	fi_man_checked,             // ̿򸫤
	fi_woman_checked,           // ̿ν򸫤
	fi_girl_checked,            // ̿ξ򸫤
	fi_boy_checked,             // ̿ξǯ򸫤
	fi_clock_working,			// פưƤ()
	fi_clock_adjusted,          // פ㥹Ȥ˹碌(פĤOFF)
	fi_clock_striking,          // פĤ
	fi_clock_bird_appeared,     // Ļ줿(˲)
	fi_toy_bird_taken,          // Ļ
    fi_silver_key_found,        // ϧǳ̤Ĵ٤ƶθȯ
    fi_silver_key_taken,        // θꤷ
    fi_fossil_taken,            // Фꤷ

    fi_card_taken,              // 纴Υ⤬񤫤줿ȥפȤä
	fi_billiard_ball_lost,      // ӥ䡼˥ӥ䡼ɥܡ줿
	fi_essay_found,             // ǯκʸ򸫤Ĥ
	fi_essay_taken,             // ǯκʸȤä





    fi_dragon_taken,
    fi_golden_key_taken,
    fi_guestroom_1f_cabinet_opened,


    fi_bathtub_empty,           // ̾Τή
    fi_bathroom_1f_message_read,// ΢Υåɤ
    fi_mirror_taken,            // 
    fi_glasses_taken,           // 
    fi_duck_taken,              // ҥ
    fi_toilet_used,             // ȥȤä

    fi_storage_table_moved,     // ʪ֤αΥơ֥ư
    fi_storage_drawers_closed,  // ʪ֤ýڤΰФ򤷤᤿
    fi_sponge_wet,              // ݥ󥸤ˤĤǨ餷
    fi_fishing_rod_with_sponge, // Ȥݥ󥸤ĤˤʤäƤ
    fi_lantern_taken,           // 󥿥
    fi_lantern_lit,             // 󥿥äƤ롣

    fi_oven_opened,             // ֥󤬳Ƥ
    fi_chicken_taken,           // ֥ηܤä(Ȥϸ¤ʤ)

    fi_chicken_put,             // Ʋ˥֤
    fi_glasses_put,             // Ʋ˴֤
    fi_necklace_put,            // Ʋ˥ͥå쥹
    fi_plush_cat_put,           // Ʋˤ̤
    fi_large_robot_put,         // Ʋ˵ܥå
    fi_swordman_taken,          // ΤΤä
	fi_ghost_appeared,          // Ʋ˰Ȥ줿
	fi_candle_lit,              // ϹĤ
	fi_candle_taken,            // Ϲä
	fi_chicken_bone_taken,      // Ļιä

	fi_portrait_eyes_right,     // ܤ
	fi_portrait_removed,        // 򳰤
    fi_start_armor_to_guestroom,  // 2FҼ˳ä
    fi_armor_to_guestroom,      // 2FҼ˳ư
    fi_armor_in_guestroom,      // 2FҼ˳줿
    fi_guestroom_2f_book_moved, // ơ֥ξܤư
    fi_logbook_found,           // Ǹ򸫤Ĥ
    fi_logbook_taken,           // ǸȤä
    fi_guestroom_2f_chair_moved, // ýڤΰػҤư
    fi_guestroom_2f_table_moved, // ýڤΥơ֥ư
    fi_guestroom_2f_cabinet_opened,
    fi_sponge_taken,
    fi_bottle_taken,

	fi_washer_opened,           // 򳫤
	fi_dryer_opened,            // 絡򳫤
	fi_bronze_key_found,        // Ƽθ򸫤Ĥ
	fi_bronze_key_taken,        // Ƽθ
    fi_dog_stood_up,            // Ω夬ä 
    fi_dog_gone,                // ¤äƤޤä
    fi_belt_taken,              // ؤ
    fi_fishing_rod_taken,       // Ȥ
    fi_poker_taken,             // Ф

    fi_attacked_on_2f,          // 2Fǽ줿Ȥ

    fi_ladder_taken,            // Ҥʥ٥åɤ鳰(Ȥϸ¤ʤ)
    fi_treasure_chest_moved,    // Ȣư
    fi_treasure_chest_unlocked, // Ȣ
    fi_treasure_chest_opened,   // Ȣ򳫤
    fi_billiard_ball_taken,     // ӥ䡼ɤζ̤
    fi_slingshot_taken,         // 줿Ѥ󤳤
	fi_slingshot_repaired,      // Ѥ󤳤

    fi_mattress_moved,          // ʥ٥åɾʤΥޥåȥ쥹ư
    fi_diary_taken,             // 
    fi_plush_cat_taken,         // ǭΤ̤ߤ

    fi_wardrobe_opened,			// ýڤ⤬Ƥ
    fi_dressing_table_unlocked,
    fi_dressing_table_opened,
    fi_branch_taken,
    fi_necklace_taken,
    fi_start_shadow,
	fi_shadow_appeared,
	fi_shadow_behind_door,
	fi_shadow_in_room,

    fi_bedroom_drawers_opened,  // ýڤΰФ򳫤
    fi_marble_found,            // ٥åɤβ˥ӡ̤ȯ
    fi_marble_taken,            // ӡ̤

    fi_start_armor_to_study,
    fi_armor_in_study,

    fi_study_library_door_closed,
    fi_study_desk_unlocked,
    fi_study_desk_opened,
//    fi_amulet_taken,
    fi_screwdriver_taken,
    //    fi_postcard_taken,
    fi_postcard_read,
    //	fi_notebook_taken,
    fi_study_notebook_read,

    fi_armor_dead, 

    fi_start_armor_to_library,
    fi_armor_in_library,
    fi_bookshelf_book_removed,
    fi_bookshelf_unlocked,
    fi_bookshelf_moved,
    //    fi_easy_necromancy_taken,
    fi_easy_necromancy_read,  // Ѥɤ
    fi_library_ladder_set,
    fi_origami_plane_taken,
    fi_fossil_set,            // Ф޽񼼤֤
    fi_armor_crushed,         // ž
    fi_armor_reviving,        // ž

	fi_pocket_notebook_dropped, // !ΤĴ٤ƼĢ
    fi_secret_room_note_read,   // !ޥɥʥɤΰɤ
    fi_candle_put,              // ŤϹ
    fi_magic_circle_invoked,    // ˡΤư
    fi_secret_room_letter_read, // !ɤ
    fi_secret_room_book_read,   // !ܤɤ

    //    fi_dragon_library,        // ɥ饴󤬿޽񼼤˽и
    fi_dragon_corridor_2f_r,  // ɥ饴2Fϭˤ
    fi_dragon_guestroom_1f,   // ɥ饴1FҼˤ
    fi_dragon_shotdown,       // ɥ饴󤬷Ȥ줿

    fi_toy_lion_taken,
    fi_witch_doll_taken,

	fi_score_found,
	fi_score_taken,
    fi_girl_doll_taken,

	fi_score_set,
	fi_score_played,
	fi_steel_key_found,
	fi_steel_key_taken,

    fi_mirror_put,
    fi_bathroom_ghost_appeared,
	fi_bathroom_2f_ghost_seen,
    fi_bathroom_2f_message_found,
    fi_bathroom_2f_message_read,

//	    fi_amulet_put,
//    fi_memo_taken,

	fi_hall_dining_door_unlocked,
    fi_hall_right_door_unlocked,
    fi_landing_door_unlocked,
    fi_music_room_door_unlocked,


	fi_cycrotron_panel_open,
	fi_cycrotron_small_door_open,
	fi_cycrotron_round_door_open,
	fi_chicken_bone_put,
	fi_rubber_duck_put,
    fi_cycrotron_activated,
    fi_boiler_room_note_read,

	fi_hat_taken,                  // 纴˹Ҥ򽦤ä

    fi_temple_spell_cast,          // ¤ʸ򾧤
	fi_great_old_one_gone,         // ۼԤԤ
    fi_temple_unsunken,            // ¤ο夬
	                               // ۼԤϢư夬ߥ󥰤
								   // Ǥ褦̥ե饰ˤ
    fi_temple_ceiling_destroyed,   // ¤ŷ˲졢ޤ
	fi_temple_burning,             // ˲ФĤ

    fi_temple_exploded,            // ˽ФƤ顢ȯ
    fi_house_burning,              // ߤ˰Ф
    fi_the_end,                    // ǥ󥰥Ф

    // ƥɥ򳫤Ȥ뤫ɤ
    fi_hall_dining_door_opened,
    fi_hall_left_door_opened,
    fi_hall_right_door_opened,
    fi_bathroom_door_opened,
	fi_dining_living_door_opened,
	fi_dining_kitchen_door_opened,
    fi_kitchen_corridor_door_opened,
    fi_laundry_corridor_door_opened,
    fi_living_corridor_door_opened,
	fi_guestroom_1f_door_opened,
    fi_storage_door_opened,
	fi_playroom_door_opened,
    fi_landing_door_opened,
    fi_boys_room_door_opened,
    fi_girls_room_door_opened,
    fi_ladys_room_door_opened,
    fi_guestroom_2f_door_opened,
    fi_study_corridor_door_opened,
    fi_library_corridor_door_opened,
    fi_bedroom_door_opened,
    fi_music_room_door_opened,
    fi_bathroom_2f_door_opened,
	fi_music_room_right_door_opened,
	fi_balcony_door_opened,
    fi_laundry_cellar_door_opened,
    fi_boiler_room_door_opened,

    // ƥꥢäȤ뤫
    fi_title_discovered,
    fi_game_over_discovered,
	fi_ending_discovered,
    fi_achievements_discovered,

    fi_mailbox_discovered,
    fi_entrance_discovered,
    fi_opened_window_discovered,
    fi_washtub_discovered,
    fi_backdoor_discovered,
    fi_under_tree_discovered,
    fi_garden_discovered,

    fi_entrance_hall_discovered,
    fi_corridor_1f_fl_discovered,
    fi_corridor_1f_bl_discovered,
    fi_corridor_1f_fr_discovered,
    fi_corridor_1f_mr_discovered,
    fi_corridor_1f_br_discovered,
    fi_bathroom_discovered,
    fi_dining_discovered,
    fi_kitchen_discovered,
    fi_laundry_discovered,
    fi_living_discovered,
    fi_guestroom_1f_discovered,
	fi_storage_discovered,
	fi_playroom_discovered,

    fi_landing_discovered,
    fi_corridor_2f_l_discovered,
    fi_corridor_2f_c_discovered,
    fi_corridor_2f_cr_discovered,
    fi_corridor_2f_r_discovered,
	
    fi_boys_room_discovered,
    fi_bed_discovered,
    fi_girls_room_discovered,
    fi_guestroom_2f_discovered,
    fi_study_discovered,
    fi_library_discovered,
    fi_bookshelf_discovered,
    fi_bedroom_discovered,
    fi_ladys_room_discovered,
    fi_wardrobe_discovered,
    fi_secret_room_discovered,
    fi_music_room_discovered,
    fi_bathroom_2f_discovered,
	fi_balcony_discovered,
    fi_balcony_down_discovered,

    fi_cellar_discovered,
    fi_boiler_room_discovered,
    fi_corridor_0f_discovered,
    fi_temple_discovered,
	fi_temple_ceiling_discovered,
	fi_cave_entrance_discovered,
    fi_cave_discovered,
    fi_under_cliff_discovered,

    fi_working_discovered,
    fi_end
} flag_id_t;

typedef enum {
    fs_begin = 0,
    fs_dragon = 0, // θɥ饴󤬻

    fs_end
} flag_sequence_id_t;

typedef struct {
    flag_id_t flags[FLAG_SEQUENCE_MAXLEN];
    int num; // ե饰
    int is_exclusive; // 0ʤ顢flags[phase]ΤON0ʤ餽ޤǤ٤ON
} flag_sequence_t;

typedef struct {
    unsigned char phase; // ƥ֤ʤ顢flags[phase]ޤΩäƤ
    unsigned char bits;
} flag_sequence_status_t;

// ʹʤ0
#define FLAG_SEQUENCE_BIT_ACTIVE 0
// 󥢥ƥ֤ΤȤϢΥ٥ȤǸޤǴλƤʤ0
//                    Ǥƥ٥ϢΤ󥻥뤵Ƥ0
#define FLAG_SEQUENCE_BIT_COMPLETE 1
// 0ʤ顢˼ưŪ˿ʹԤ
#define FLAG_SEQUENCE_BIT_AUTO   2


typedef struct {
    flag_id_t id;
    int value;
    int score;
} point_t;

#define FLAG_CHAR_NUM (fi_end/8+1)

#define FLAG_SEQUENCE_MAXNUM 128

typedef struct {
	// area_id_tֻΥǥ򤱤뤿charȤ
	// areag_id255ĶʤȤ
	//    area_id_t current_area;
    unsigned char current_area;
    // ʪθĿ
	unsigned char item_num;
    // ʪnoun_id
    unsigned char items[ITEM_MAX];
    // ƥե饰ξ
    flag_sequence_status_t flag_sequence[FLAG_SEQUENCE_MAXNUM];
    // Ƽե饰
    unsigned char flags[FLAG_CHAR_NUM];
} status_t;

#define Is(f) (is_flag_on(fi_ ## f))
#define Not(f) (is_flag_off(fi_ ## f))
#define Set(f) set_flag(fi_ ## f)
#define Reset(f) reset_flag(fi_ ## f)
#define Toggle(f) toggle_flag(fi_ ## f)
#define TestAndSet(f, msg1, msg2) test_and_set_flag(fi_ ## f, msg1, msg2)
#define TestAndReset(f, msg1, msg2) test_and_reset_flag(fi_ ## f, msg1, msg2)
#define Has(f) (has_item(ni_ ## f))
#define HasNot(f) (!has_item(ni_ ## f))
#define Active(fs) (is_flag_sequence_active(fs_ ## fs))
#define NotActive(fs) (!is_flag_sequence_active(fs_ ## fs))
#define Complete(fs) (is_flag_sequence_complete(fs_ ## fs))

void status_init(char *edir);
void clear_status(void);
area_id_t current_area_id(void);
void set_area_id(area_id_t id);
int is_flag_on(flag_id_t fid);
int is_flag_off(flag_id_t fid);
void set_flag(flag_id_t fid);
void reset_flag(flag_id_t fid);
void test_and_set_flag(flag_id_t fid, char *msg_success, char *msg_failure);
void test_and_reset_flag(flag_id_t fid, char *msg_success, char *msg_failure);
void toggle_flag(flag_id_t fid);
int has_item(noun_id_t nid);
void get_item(noun_id_t nid);
void lose_item(noun_id_t nid);
int get_item_num(void);
noun_id_t get_item_id(int ix);
void show_score(char *msg, point_t points[], int point_num);
void show_normal_score(void);
void show_maniac_score(void);


FILE *open_data(char *file, char *mode);
int load_data(void);
int save_data(void);
void set_config_input(input_mode_t mode);
input_mode_t get_config_input(void);

void clear_flag_sequence(flag_sequence_id_t fs);
void start_flag_sequence(flag_sequence_id_t fs);
void proceed_flag_sequence(flag_sequence_id_t fs);
void abort_flag_sequence(flag_sequence_id_t fs);
void set_flag_sequence_active(flag_sequence_id_t fs);
void reset_flag_sequence_active(flag_sequence_id_t fs);
int is_flag_sequence_active(flag_sequence_id_t fs);
void set_flag_sequence_complete(flag_sequence_id_t fs);
int is_flag_sequence_complete(flag_sequence_id_t fs);
int has_light(void);
#endif
